/*
 * Copyright 2008 Alberto Gimeno <gimenete at gmail.com>
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 */
package siena;

/**
 * This class contains few choices to select the id strategy generation.
 * 
 * <ul>
 *   <li>NONE - It means not id strategy defined, the user must handle the id generation. </li>
 *   <li>AUTO_INCREMENT - In this case, the id will be filled by the id generated by the data base.</li>
 *   <li>SEQUENCE - Usually this strategy use a database sequence to generate the id from the data base server.</li>
 *   <li>UUID - TBD</li>
 * </ul>
 * 
 * @author gimenete
 *
 */
public enum Generator {

	NONE, AUTO_INCREMENT, SEQUENCE, UUID

} // Generator.
